"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FieldObjectRef = void 0;
const react_1 = __importStar(require("react"));
const prop_types_1 = __importDefault(require("prop-types"));
const components_search_and_select_dropdown_1 = require("@react_db_client/components.search-and-select-dropdown");
const parseVal = (val) => {
    if (!val) {
        return [];
    }
    return Array.isArray(val) ? val : [val];
};
const getSearchFieldPlaceholder = (val, field) => {
    return val[0] ? val[0][field] : 'Search...';
};
const SelectedItems = ({ items, labelField, handleItemClick }) => {
    return (react_1.default.createElement("div", { className: "" }, items.map((item) => (react_1.default.createElement("button", { type: "button", className: "button-one", onClick: () => handleItemClick(item.uid, item) }, item[labelField])))));
};
const searchFn = (asyncGetDocuments, collection, schema, sortBy) => (filters) => __awaiter(void 0, void 0, void 0, function* () {
    return asyncGetDocuments(collection, filters || [], schema, sortBy);
});
/**
 * A form field that deals with object id references
 */
const FieldObjectRef = ({ uid, unit, updateFormData, value, multiple, collection, required, labelField, // The field in the returned data to use as the label
allowEmptySearch, asyncGetDocuments, }) => {
    let valueChecked = (0, react_1.useMemo)(() => parseVal(value), [value]);
    let searchFieldPlaceholder = multiple
        ? 'Choose from dropdown...'
        : getSearchFieldPlaceholder(valueChecked, labelField);
    const handleSelect = (0, react_1.useCallback)(
    // eslint-disable-next-line no-unused-vars
    (selectedId, data) => {
        const newData = multiple
            ? [...valueChecked, data].filter((v, i, self) => self.findIndex((vv) => vv.uid == v.uid) == i)
            : data;
        updateFormData(uid, newData);
        // if (newVal !== value) updateFormData(uid, newVal);
    }, [updateFormData, uid, multiple, valueChecked]);
    const handleSelectedClick = (0, react_1.useCallback)((itemUid) => {
        const newData = valueChecked.filter((v) => v.uid !== itemUid);
        updateFormData(uid, newData);
    }, [updateFormData, uid, valueChecked]);
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(components_search_and_select_dropdown_1.SearchAndSelectDropdown, { searchFunction: searchFn(asyncGetDocuments, collection, '_id', labelField), handleSelect: handleSelect, initialValue: valueChecked, allowMultiple: multiple, searchFieldTargetField: labelField, labelField: labelField, className: "formFieldInput", searchFieldPlaceholder: searchFieldPlaceholder, 
            // onChange={(e) => updateFormData(uid, e.target.value)}
            required: required, allowEmptySearch: allowEmptySearch }),
        multiple && (react_1.default.createElement(SelectedItems, { items: valueChecked, labelField: labelField, handleItemClick: handleSelectedClick })),
        unit && react_1.default.createElement("span", null, unit)));
};
exports.FieldObjectRef = FieldObjectRef;
const objRefShape = {
    _id: prop_types_1.default.string.isRequired,
    uid: prop_types_1.default.string.isRequired,
    name: prop_types_1.default.string,
    label: prop_types_1.default.string,
};
exports.FieldObjectRef.propTypes = {
    uid: prop_types_1.default.string.isRequired,
    unit: prop_types_1.default.string,
    value: prop_types_1.default.oneOfType([
        prop_types_1.default.shape(objRefShape),
        prop_types_1.default.arrayOf(prop_types_1.default.shape(objRefShape)),
    ]),
    updateFormData: prop_types_1.default.func.isRequired,
    multiple: prop_types_1.default.bool,
    required: prop_types_1.default.bool,
    labelField: prop_types_1.default.string,
    collection: prop_types_1.default.string.isRequired,
    allowEmptySearch: prop_types_1.default.bool,
    /* Async func to get documents for selection
     * Signature: (collection<string>, filters<Array>, schema<String>, sortBy<String>) => <Array>
     */
    asyncGetDocuments: prop_types_1.default.func.isRequired,
};
exports.FieldObjectRef.defaultProps = {
    unit: '',
    value: null,
    multiple: false,
    // defaultVal: null,
    required: false,
    labelField: 'label',
    allowEmptySearch: false,
};
//# sourceMappingURL=field-object-ref.js.map